﻿import hdk.sdlimage;
import hdk.sdlttf;
import std.cstream;
import std.utf;
import std.thread;
import std.string;
import std.random;
import hdk.window;
import hdk.sdlbase;

const dchar[] TEST_TEXT = "あいうえおabcdefghijklmnopqrstuvwxyz";
const dchar[] FONT_FILE_NAME1 = `C:\WINDOWS\Fonts\msgothic.ttc`;
const dchar[] FONT_FILE_NAME2 = `C:\WINDOWS\Fonts\verdana.ttf`;

int main()
{
	try
	{
		uint[] pixels;
		uint height = 0;
		
		setTtfFileName(FONT_FILE_NAME1);
		setTtfFontStyleBoldItalicUnderline(true, true, true);
		foreach (dchar[] text; splitTextTexture512x32(TEST_TEXT))
		{
			pixels ~= createTextTexture512x32(text);
			height += 32;
		}
		
		setTtfFileName(FONT_FILE_NAME2);
		setTtfFontStyleBoldItalicUnderline(false, false, false);
		foreach (dchar[] text; splitTextTexture512x32(TEST_TEXT))
		{
			pixels ~= createTextTexture512x32(text);
			height += 32;
		}
		
		foreach (inout uint a; pixels)
		{
			ubyte alpha = cast(ubyte)(a >> 24);
			a = 0xff000000 | alpha << 16 | alpha << 8 | alpha;
		}
		
		writeBitmap("sdlttf_test.bmp", pixels, 512, height);
		
		// スレッドセーフかどうか試す
		A a = new A();
		a.wait();
		
		test();
		
		dout.writeLine("ok");
		dout.flush();
	}
	catch (Exception e)
	{
		derr.writeLine("Exception: " ~ e.toString());
	}
	return 0;
}

class A : Thread
{
	this() { start(); }
	
	int run()
	{
		setTtfFileName = FONT_FILE_NAME1;
		foreach (dchar[] a; splitTextTexture512x32(TEST_TEXT)) dout.writeLine(toUTF8(a));
		return 0;
	}
}

void test()
{
	auto Window wnd = new Window();
	while (true)
	{
		dchar[] t = Vector.create(wnd.mouseX, wnd.mouseY).toString().toUTF32();
		dchar[] t2 = splitTextTexture512x32(t)[0];
		wnd.drawText(t2, vector(1, 1, 1, 1));
		wnd.update();
		sleep(1);
	}
}
