﻿import hdk.window;
import hdk.control;
import std.cstream;

int main()
{
	try
	{
		auto Window wnd = new Window();
		
		Canvas canvas = new Canvas(wnd.rootControl);
		Canvas canvas2 = new Canvas(wnd.rootControl);
		canvas2.color = Vector(1, 1, 0, 1);
		canvas2.modelView = Matrix.translation(0.1, 0.1, 0);
		canvas2.z = -1.0;
		
		ImageBox imageBox = new ImageBox(wnd.rootControl);
		imageBox.textureFileName = `..\resource\test0.png`;
		imageBox.modelView = Matrix.translation(-0.1, -0.1, 0);
		imageBox.color = Vector(1, 0, 0, 0.5);
		
		StaticText staticText = new StaticText(wnd.rootControl);
		staticText.text = "hoge";
		
		Button button = new Button(wnd.rootControl);
		void writeButton() { dout.writeLine("button"); staticText.cutLink(); }
		with (button)
		{
			text = "button";
			rectangle = Rectangle(-0.9, 0.8, 0.3, 0.1);
			foreColor = Vector(1, 0, 0, 1);
			backColor = Vector(1, 1, 1, 1);
			pushedEvent = &writeButton;
		}
		
		ProgressBar pb = new ProgressBar(wnd.rootControl);
		with (pb)
		{
			rectangle = Rectangle(-0.9, -0.9, 1.8, 0.1);
			foreColor = Vector(0, 1, 0, 1);
			backColor = Vector(1, 0, 1, 1);
		}
		
		Slider slider = new Slider(wnd.rootControl);
		void putSliderValue(float value) { dout.writefln("slider %f", value); }
		with (slider)
		{
			rectangle = Rectangle(0.8, -0.8, 0.05, 1.6);
			foreColor = Vector(0, 0, 1, 1);
			backColor = Vector(1, 1, 0, 1);
			changedEvent = &putSliderValue;
			slider.value = 0.5;
		}
		
		CheckBox cb = new CheckBox(wnd.rootControl);
		void writeCheckButton(bit a) { dout.writefln("check %s", a ? "on" : "off"); }
		with (cb)
		{
			text = "check";
			rectangle = Rectangle(-0.9, 0.6, 0.3, 0.1);
			foreColor = Vector(1, 1, 0, 1);
			backColor = Vector(1, 0.5, 0.5, 1);
			checkedEvent = &writeCheckButton;
		}
		
		RadioGroup rg = new RadioGroup(wnd.rootControl);
		void writeSelect(uint index) { dout.writefln("select %d", index); }
		with (rg)
		{
			rg.length = 3;
			rg[0].text = "a";
			rg[1].text = "b";
			rg[2].text = "c";
			rg.rectangle = Rectangle(-0.9, 0.4, 0.6, 0.1);
			foreColor = Vector(1, 0, 0, 1);
			backColor = Vector(0, 1, 0, 1);
			borderColor = Vector(0, 0, 1, 1);
			selectedEvent = &writeSelect;
		}
		
		ImageButton ib = new ImageButton(wnd.rootControl);
		void writeImageButton() { dout.writeLine("image button"); }
		with (ib)
		{
			text = "image button";
			textureFileName = `..\resource\test1.png`;
			rectangle = Rectangle(-0.9, 0.1, 0.9, 0.2);
			imageWidth = 0.2;
			textHeight = 0.1;
			foreColor = Vector(1, 1, 1, 1);
			backColor = Vector(1, 1, 1, 1);
			pushedEvent = &writeImageButton;
		}
		
		while (wnd.alive)
		{
			pb.value += 0.01;
			if (pb.value > 1.0) pb.value = 0.0;
			
			sleep(15);
		}
	}
	catch (Exception e)
	{
		derr.writeLine(e.toString());
	}
	return 0;
}
