﻿import nanami.mqo;
import nanami.toutf8fromsjis;
import std.cstream;
import std.file;

int main()
{
	try
	{
		dout.writeLine("mqo test begin...");
		
		const char[] MQO_FILE_NAME = `..\resource\test.mqo`;
		//const char[] MQO_FILE_NAME = `..\resource\test2.mqo`;
		
		char[] src = cast(char[])read(MQO_FILE_NAME);
		src = toUtf8FromSjis(src);
		Mqo mqo = new Mqo(new MemoryStream(src));
		MemoryStream a = new MemoryStream(src);
		MemoryStream b = new MemoryStream(mqo.toString());
		int line = 1;
		while (true)
		{
			if (a.eof && b.eof) break;
			assert(!a.eof && !b.eof);
			char[] text1 = a.readLine();
			char[] text2 = b.readLine();
			char[] text1m = text1 ~ " M(0)"; // 判定できないので
			if (text1 != text2 && text1m != text2)
			{
				dout.writefln("%d:%s:%s", line, text1, text2);
				assert(false);
			}
			line++;
		}
		
		dout.writeLine("mqo test end");
	}
	catch (Exception e)
	{
		derr.writeLine(e.toString());
	}
	return 0;
}
