﻿import std.cstream;
import std.file;
import nanami.toutf8fromsjis;
import nanami.mkm;

int main()
{
	try
	{
		dout.writeLine("mkm test begin...");
		
		const char[] MKM_FILE_NAME = `..\resource\test0.mkm`;
		//const char[] MKM_FILE_NAME = `..\resource\test1.mkm`;
		//const char[] MKM_FILE_NAME = `..\resource\test2.mkm`;
		
		char[] src = cast(char[])read(MKM_FILE_NAME);
		src = toUtf8FromSjis(src);
		Mkm mkm = new Mkm(new MemoryStream(src));
		MemoryStream a = new MemoryStream(src);
		MemoryStream b = new MemoryStream(mkm.toString());
		int line = 1;
		while (true)
		{
			if (a.eof && b.eof) break;
			assert(!a.eof && !b.eof);
			char[] text1 = a.readLine();
			char[] text2 = b.readLine();
			if (text1 != text2)
			{
				dout.writefln("%d: %s : %s", line, text1, text2);
				assert(false);
			}
			line++;
		}
		
		dout.writeLine("mkm test end");
	}
	catch (Exception e)
	{
		derr.writeLine(e.toString());
	}
	return 0;
}
